% Test Convexified Modularity Maximization (CMM) on the political blogs 
% dataset from Adamic and Glance (2005)
%
% Reference:
%	A. Adamic and N. Glance. 
%	"The political blogosphere and the 2004 U.S. election: divided they blog." 
%   In Proceedings of the 3rd International Workshop on Link Discovery, 
%   ACM, New York, pages 36?43, 2005.


%% Load the political dataset
clear;
load 'polblogs.mat';

A = polblogsgiant;         % Adjacency matrix of the giant component
IDX_true = polblogsgianty; % "True" cluster labels
n=size(A,1);               % Number of nodes


%% Clustering using CMM
r=2;
IDX = CMM(A, r);


%% Output number of misclassification nodes
IDX = IDX(:);     
mis = min( nnz(IDX - IDX_true), nnz(3-IDX - IDX_true) );
fprintf('# misclassified nodes: %d (out of %d)\n', mis, n);